Unit IDS8R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IDS8R(var X :Array of Real; var Y :Array of Real;
                N :Integer; YP1 :Real; YPN :Real;
                var Y2 :Array of Real; var U :Array of Real);

implementation

procedure IDS8R(var X :Array of Real; var Y :Array of Real;
                N :Integer; YP1 :Real; YPN :Real;
                var Y2 :Array of Real; var U :Array of Real);
var
N1,I,K,K1 :Integer;
SIG,P,QN,UN :Real;
const
SYS071 :Real = 1.844674E19;
ZERO :Real = 0.0;
label
_10,_20,_30,_40,_50,_60;
begin
if ( YP1 <= SYS071 ) 
 then goto _10;
Y2[0] := ZERO;
U[0] := ZERO;
goto _20;
_10:
Y2[0] := -0.5;
U[0] := (3.0/(X[1]-X[0]))*((Y[1]-Y[0])/(X[1]-X[0])-YP1);
_20:
N1 := N-1;
for I:=2 to N1 do
 begin
  SIG := (X[I-1]-X[I-2])/(X[I+0]-X[I-2]);
  P := SIG*Y2[I-2]+2.0;
  Y2[I-1] := (SIG-1.0)/P;
  U[I-1] := (6.0*((Y[I+0]-Y[I-1])/(X[I+0]-X[I-1])-(Y[I-1]-Y[I-2])
    /(X[I-1]-X[I-2]))/(X[I+0]-X[I-2])-SIG*U[I-2])/P;
_30:
 end;
if ( YPN <= SYS071 ) 
 then goto _40;
QN := ZERO;
UN := ZERO;
goto _50;
_40:
QN := 0.5;
UN := (3.0/(X[N-1]-X[N-2]))*(YPN-(Y[N-1]-Y[N-2])/(X[N-1]-X[N-2]));
_50:
Y2[N-1] := (UN-QN*U[N-2])/(QN*Y2[N-2]+1.0);
for K1:=1 to N1 do
 begin
  K := N1-K1+1;
  Y2[K-1] := Y2[K-1]*Y2[K+0]+U[K-1];
_60:
 end;
end;

end.
